/* eslint-disable */
!(function(root, factory) {
  /* eslint-enable */
  if (typeof window === 'undefined') {
    // 为了 node 里引入不报错
    module.exports = {};
  } else if (typeof module === 'object' && module.exports) {
    module.exports = factory();
  } else {
    // 供用户调用 iqiyi.xxxx
    root.iqiyi = root.iqiyi || factory();
  }
})(typeof self !== 'undefined' ? self : this, function() {
  var ua = window.navigator.userAgent;
  var isiOS =
    !!ua.match(/\(i[^;]+;( U;)? CPU.+Mac OS X/) || !!ua.match(/\(i[^;]+; iOS/) || !!ua.match(/\(Macintosh; iOS/) || !!ua.match(/Macintosh/);
  var isIQIYIWebView = !!ua.match(/ IqiyiApp\/(.+) IqiyiVersion\/([\d\.]+)/);
  var isNewVersion = false;
  var handlerCount;
  var lastHandlerCount;
  var emptyCallback = {
    fail: emptyFn,
    success: emptyFn,
    cancel: emptyFn
  };

  function emptyFn() {}

  function callScheme(src, params) {
    var QYIframe = window.document.createElement('iframe');
    QYIframe.style.display = 'none';
    QYIframe.src = src;
    window.document.documentElement.appendChild(QYIframe);
    setTimeout(function() {
      window.document.documentElement.removeChild(QYIframe);
    }, 0);
  }

  function isPlayerFullScreen() {
    let ua = window.navigator.userAgent;
    return !!ua.match(/PLAYER_FULL/)
  }

  function jump(src) {
    window.location.href = src;
  }

  try {
    if (isiOS) {
      isNewVersion = ua.indexOf('QYWebContainer') !== -1 || window.webkit.messageHandlers.__$$$_native_call_ !== undefined
    } else {
      isNewVersion = window.__$$$_native_call_.invoke !== undefined;
    }
  } catch (e) {
    emptyFn();
  }

  if (isNewVersion) {
    handlerCount = lastHandlerCount = 0;
  }

  if (isiOS && isIQIYIWebView && !isNewVersion) {
    callScheme('qyjbscheme://__BRIDGE_LOADED__');
  }

  var iqiyi = {
    VERSION: '3.0.0',
    callbacks: {},
    collectPerformance: false,
    collectRate: 0.2,

    JSBRIDGE_INIT_PAGE: 'JSBRIDGE_INIT_PAGE',
    JSBRIDGE_LOGIN: 'JSBRIDGE_LOGIN',
    JSBRIDGE_LOGOUT: 'JSBRIDGE_LOGOUT',
    JSBRIDGE_SHARE: 'JSBRIDGE_SHARE',
    JSBRIDGE_SHARE_DATA: 'JSBRIDGE_SHARE_DATA',
    JSBRIDGE_CHARGE: 'JSBRIDGE_CHARGE',
    JSBRIDGE_SCAN_QRCODE: 'JSBRIDGE_SCAN_QRCODE',
    JSBRIDGE_UPLOAD_VIDEO: 'JSBRIDGE_UPLOAD_VIDEO',
    JSBRIDGE_SYNC_USER: 'JSBRIDGE_SYNC_USER',
    JSBRIDGE_LOAD_PAGE: 'JSBRIDGE_LOAD_PAGE',
    JSBRIDGE_SHOW_MENU: 'JSBRIDGE_SHOW_MENU',
    JSBRIDGE_HIDE_MENU: 'JSBRIDGE_HIDE_MENU',
    JSBRIDGE_CLOSE_PAGE: 'JSBRIDGE_CLOSE_PAGE',
    JSBRIDGE_GEN_IA: 'JSBRIDGE_GEN_IA',
    JSBRIDGE_INSIDE_STORE: 'JSBRIDGE_INSIDE_STORE',
    JSBRIDGE_SYNC_DATA: 'JSBRIDGE_SYNC_DATA',

    // 插件安装状态查询
    JSBRIDGE_STATUS_PLUGIN: 'JSBRIDGE_STATUS_PLUGIN',
    // 插件下载, 下载状态查询
    JSBRIDGE_DOWNLOAD_PLUGIN: 'JSBRIDGE_DOWNLOAD_PLUGIN',
    // 第三方 app 安装状态查询
    JSBRIDGE_STATUS_APP: 'JSBRIDGE_STATUS_APP',
    // 第三方 app下载(静默, 非静默), 下载进度查询
    JSBRIDGE_DOWNLOAD_APP: 'JSBRIDGE_DOWNLOAD_APP',
    // 吊起系统安装器
    JSBRIDGE_INSTALL_APP: 'JSBRIDGE_INSTALL_APP',
    // 启动第三方 app
    JSBRIDGE_OPEN_APP: 'JSBRIDGE_OPEN_APP',

    // 选取图片
    JSBRIDGE_SELECT_IMAGE: 'JSBRIDGE_SELECT_IMAGE',

    // 设置是否持返回按钮
    JSBRIDGE_SET_GOBACK: 'JSBRIDGE_SET_GOBACK',

    JSBRIDGE_ROUTER: 'JSBRIDGE_ROUTER',

    // 打开语音
    JSBRIDGE_OPEN_VOICE_SEARCH: 'JSBRIDGE_OPEN_VOICE_SEARCH',

    // 停止录音
    JSBRIDGE_STOP_RECORD_AUDIO: 'JSBRIDGE_STOP_RECORD_AUDIO',

    // 拦截右上角点击事件
    JSBRIDGE_INTERCEPTE_CLICK: 'JSBRIDGE_INTERCEPTE_CLICK',

    MAX_COUNT: 10,

    invokeNative: function(type, request) {
      // 调起native接口
      var obj;
      // 老版本有可能调用方法初始化的时候不存在, 所以这里还是要写一份
      var handlerFn;
      var self;
      try {
        if (isNewVersion) {
          // 没有绑 callback 的函数不需要 callback
          var currentCount;
          if (lastHandlerCount !== handlerCount) {
            currentCount = handlerCount;
          } else {
            currentCount = -1;
          }
          obj = {
            func: type,
            arguments: request || {},
            callback_handle: currentCount
          };
          lastHandlerCount = handlerCount;
          if (isiOS) {
            handlerFn =
              window.webkit.messageHandlers.__$$$_native_call_.postMessage;
            self = window.webkit.messageHandlers.__$$$_native_call_;
          } else {
            handlerFn = window.__$$$_native_call_.invoke;
            self = window.__$$$_native_call_;
          }
        } else {
          obj = {
            type: type,
            request: request || null
          };
          handlerFn = window.IqiyiJsBridge.invoke;
          self = window.IqiyiJsBridge;
        }
        var jsonString = JSON.stringify(obj);
        console.log('call native: ' + jsonString);
        handlerFn.call(self, jsonString);
      } catch (e) {
        console.log('invoke fail: ' + JSON.stringify(obj));
        console.warn(e.message);
      }
    },

    invoke: function(jsonString) {
      // 获取native返回数据
      try {
        var result =
          typeof jsonString === 'string' ? JSON.parse(jsonString) : jsonString;
        console.log('native call: ' + JSON.stringify(result));
        if (isNewVersion) {
          var handle = result.handle;
          this.runCallback(this.callbacks[handle], result.result);
          // TODO delete function already used
          // TODO 测试 JSBRIDGE_SHARE_DATA, JSBRIDGE_INIT_PAGE 的正确性
        } else {
          switch (result.type) {
            case this.JSBRIDGE_INIT_PAGE:
              this.callbacks[result.type].shift()(result.response);
              break;
            case this.JSBRIDGE_SHARE_DATA:
              if (result.response) {
                this.runCallback(this.callbacks[result.type], result.response);
              } else {
                // TODO 不知道这里要干什么, 暂时留着..
                this.onShare.trigger.call(this.onShare.request);
                this.invokeNative(
                  this.JSBRIDGE_SHARE_DATA,
                  this.onShare.request
                );
              }
              break;
            default:
              this.runCallback(this.callbacks[result.type], result.response);
          }
        }
      } catch (e) {
        console && typeof console.error === 'function' && console.error(e);
      }
    },

    setCallback: function(key, param) {
      var fn = {};
      if (typeof param === 'object') {
        fn.success =
          typeof param.success === 'function' ? param.success : emptyFn;
        fn.fail = typeof param.fail === 'function' ? param.fail : emptyFn;
        fn.cancel = typeof param.cancel === 'function' ? param.cancel : emptyFn;
      } else {
        fn.callback = typeof param === 'function' ? param : emptyFn;
      }
      if (isNewVersion) {
        handlerCount++;
        this.callbacks[handlerCount] = fn;
      } else {
        this.callbacks[key] = fn;
      }
      console.log('setCallback:' + key);
    },

    runCallback: function(key, res) {
      var response = res || {};
      var fn = key || emptyCallback;
      // 老版本 ios 里 result 为 string, 需要转一下
      response.result = parseInt(response.result);
      if (fn.callback) {
        fn.callback(response);
      } else {
        if (response.result === 0) {
          fn.fail(response.data, response.msg, response);
        } else if (response.result === 1) {
          fn.success(response.data, response.msg, response);
        } else if (response.result === 2) {
          fn.cancel(response.data, response.msg, response);
        }
      }
    },

    ready: function(callback) {
      var self = this;
      if (typeof callback !== 'function') {
        return;
      }
      // 老容器 + 新容器安卓 + 新容器ios
      if (window.IqiyiJsBridge || window.__$$$_native_call_ || (window.webkit && window.webkit.messageHandlers && window.webkit.messageHandlers.__$$$_native_call_)) {
        callback(true);
      } else {
        setTimeout(function() {
          if (self.MAX_COUNT-- > 0) {
            self.ready(callback);
          } else {
            callback(false);
          }
        }, 500);
      }
    },

    init: function(callback) {
      // 获取页面初始化信息
      if (isNewVersion) {
        this.setCallback(this.JSBRIDGE_INIT_PAGE, callback);
      } else {
        this.callbacks[this.JSBRIDGE_INIT_PAGE] =
          this.callbacks[this.JSBRIDGE_INIT_PAGE] || [];
        this.callbacks[this.JSBRIDGE_INIT_PAGE].push(
          typeof callback === 'function' ? callback : emptyFn
        );
      }
      this.invokeNative(this.JSBRIDGE_INIT_PAGE);
    },

    login: function(url) {
      // 拉起native登录
      this.invokeNative(
        this.JSBRIDGE_LOGIN,
        url
          ? {
              returnUrl: url
            }
          : null
      );
    },

    logout: function(url) {
      // 拉起native登出
      this.invokeNative(
        this.JSBRIDGE_LOGOUT,
        url
          ? {
              returnUrl: url
            }
          : null
      );
    },

    share: function(param) {
      // 拉起native分享
      var TARGET_API = isPlayerFullScreen() ? 'JSBRIDGE_PLAYER_FULL_SHARE' : this.JSBRIDGE_SHARE;
      var request = this.setShareData(param);
      this.setCallback(TARGET_API, param);
      this.invokeNative(TARGET_API, request);
    },

    onShare: function(param) {
      var request = this.setShareData(param);
      this.setCallback(this.JSBRIDGE_SHARE_DATA, param);
      this.invokeNative(this.JSBRIDGE_SHARE_DATA, request);
    },

    setShareData: function(param) {
      param = param || {};
      var request = {
        item: param.item || [],
        title: param.title || document.title || '',
        desc: param.desc || '',
        imgUrl:
          param.imgUrl ||
          'http://pic9.iqiyipic.com/common/20151208/87b50785390941e58c30b681d82d76b9.png',
        link: param.link || window.location.href,
      };
      if (param.mp_imageUrl) {
        request.mp_imageUrl = param.mp_imageUrl
      }
      if (param.mp_path) {
        request.mp_path = param.mp_path
        request.shareType = 5
      }
      for (var key in param) {
        if (!(key in request)) {
          request[key] = param[key]
        }
      }
      if (request.shareType == 5 && !request.mp_path) {
        throw new Error('shareType 为 5 时，必须设置分享的小程序路径 mp_path')
      }
      return request;
    },

    charge: function(param) {
      // 拉起native收银台
      param = param || {};
      this.setCallback(this.JSBRIDGE_CHARGE, param);
      this.invokeNative(this.JSBRIDGE_CHARGE, param);
    },

    scanQRCode: function(callback) {
      // 拉起native扫描二维码
      this.setCallback(this.JSBRIDGE_SCAN_QRCODE, callback);
      this.invokeNative(this.JSBRIDGE_SCAN_QRCODE);
    },

    uploadVideo: function(param) {
      // 拉起native视频上传
      param = param || {};
      var request = {
        id: param.id || '',
        title: param.title || document.title || '',
        returnUrl: param.returnUrl || window.location.href
      };
      this.setCallback(this.JSBRIDGE_UPLOAD_VIDEO, param);
      this.invokeNative(this.JSBRIDGE_UPLOAD_VIDEO, request);
    },

    syncUser: function(param) {
      // 更新native用户信息
      param = param || {};
      var request = {
        authcookie: param.authcookie || ''
      };
      this.setCallback(this.JSBRIDGE_SYNC_USER, param);
      this.invokeNative(this.JSBRIDGE_SYNC_USER, request);
    },

    loadNativePage: function(param) {
      // 打开native页面
      param = param || {
        returnUrl: window.location.href
      };
      if (!param.page) {
        return;
      }
      this.invokeNative(this.JSBRIDGE_LOAD_PAGE, param);
    },

    showMenu: function(param) {
      // 定制显示右上角菜单
      param = param || {};
      var request = {
        share: !!param.share,
        menus: []
      };
      if (param.prizeRecord) {
        request.menus.push({
          icon:
            'http://pic7.iqiyipic.com/common/20170905/16deb64aab4447b8a69de6a270937f3a.png',
          text: '获奖记录',
          link: 'http://activity.m.iqiyi.com/html5/userprize'
        });
      }
      if (param.customService) {
        request.menus.push({
          icon:
            'http://pic6.iqiyipic.com/common/20170905/1a80a205967646e0a0dee2eb43263639.png',
          text: '联系客服',
          link: 'http://activity.m.iqiyi.com/html5/customservice'
        });
      }
      if (param.menus) {
        request.menus = request.menus.concat(param.menus);
      }
      this.invokeNative(this.JSBRIDGE_SHOW_MENU, request);
    },

    hideMenu: function(param) {
      // 隐藏右上角菜单
      this.invokeNative(this.JSBRIDGE_HIDE_MENU, param);
    },

    closePage: function(param) {
      // 关闭当前webview
      this.invokeNative(this.JSBRIDGE_CLOSE_PAGE, param);
    },

    getInferiorAccount: function(callback) {
      // 获取亚账号信息
      this.setCallback(this.JSBRIDGE_GEN_IA, callback);
      this.invokeNative(this.JSBRIDGE_GEN_IA);
    },

    openAppStore: function(appid, options) {
      // 打开苹果商店
      if (appid) {
        this.invokeNative(this.JSBRIDGE_INSIDE_STORE, {
          appid: appid,
          options: options || {}
        });
      }
    },

    syncData: function(param) {
      param = param || {};
      if (!param.method || (param.method !== 'set' && param.method !== 'get')) {
        return;
      }
      var request = {
        method: param.method,
        options: param.options || {}
      };
      this.setCallback(this.JSBRIDGE_SYNC_DATA, param);
      this.invokeNative(this.JSBRIDGE_SYNC_DATA, request);
    },

    checkStatusApp: function(params, callback) {
      this.setCallback(this.JSBRIDGE_STATUS_APP, callback);
      this.invokeNative(this.JSBRIDGE_STATUS_APP, params);
    },

    downloadApp: function(params, callback) {
      this.setCallback(this.JSBRIDGE_DOWNLOAD_APP, callback);
      this.invokeNative(this.JSBRIDGE_DOWNLOAD_APP, params);
    },

    installApp: function(params, callback) {
      this.setCallback(this.JSBRIDGE_INSTALL_APP, callback);
      this.invokeNative(this.JSBRIDGE_INSTALL_APP, params);
    },

    openApp: function(params, callback) {
      this.setCallback(this.JSBRIDGE_OPEN_APP, callback);
      this.invokeNative(this.JSBRIDGE_OPEN_APP, params);
    },

    checkStatusPlugin: function(params, callback) {
      this.setCallback(this.JSBRIDGE_STATUS_PLUGIN, callback);
      this.invokeNative(this.JSBRIDGE_STATUS_PLUGIN, params);
    },

    downloadPlugin: function(params, callback) {
      this.setCallback(this.JSBRIDGE_DOWNLOAD_PLUGIN, callback);
      this.invokeNative(this.JSBRIDGE_DOWNLOAD_PLUGIN, params);
    },

    selectImage: function(params, callback) {
      this.setCallback(this.JSBRIDGE_SELECT_IMAGE, callback);
      this.invokeNative(this.JSBRIDGE_SELECT_IMAGE, params);
    },

    setGoback: function(params, callback) {
      this.setCallback(this.JSBRIDGE_SET_GOBACK, callback);
      this.invokeNative(this.JSBRIDGE_SET_GOBACK, params);
    },

    openWebview: function(options) {
      var params = options || {};
      var url =
        'iqiyi-phone://com.qiyi.video/res?pid=' +
        (params.pid || 8) +
        '&url=' +
        encodeURIComponent(params.url) +
        '&title=' +
        encodeURIComponent(params.title);
      console.log('open: ' + url);
      jump(url);
    },

    openPage: function(params, callback) {
      this.setCallback(this.JSBRIDGE_ROUTER, callback);
      this.invokeNative(this.JSBRIDGE_ROUTER, params);
    },

    openVoicesearch: function(callback) {
      this.setCallback(this.JSBRIDGE_OPEN_VOICE_SEARCH, callback);
      this.invokeNative(this.JSBRIDGE_OPEN_VOICE_SEARCH);
    },
    stopRecordAudio: function(callback) {
      this.setCallback(this.JSBRIDGE_STOP_RECORD_AUDIO, callback);
      this.invokeNative(this.JSBRIDGE_STOP_RECORD_AUDIO);
    },

    handleRightbtnClick: function(callback) {
      this.setCallback(this.JSBRIDGE_INTERCEPTE_CLICK, callback);
      // TODO 为了通知native 正确的 handler
      this.invokeNative(this.JSBRIDGE_INTERCEPTE_CLICK);
    },

    // 通用的 invoke 方法
    commonInvoke: function(type, params, callback) {
      var currentType = this[type] || type;
      // if (!this[type]) {
      //   console.warn('type ' + type + ' invalid or new type');
      // }
      if (callback) {
        this.setCallback(currentType, callback);
      }
      this.invokeNative(currentType, params);
    }
  };

  // 需要 window.iqiyi.invoke 全局方法
  if (isNewVersion) {
    window.QIYI = iqiyi;
  } else {
    window.iqiyi = iqiyi;
  }

  return iqiyi;
});
